#!/usr/bin/env Python
# -*- coding: utf-8 -*-
import scribus

#################################
# settings:

# number of tickets:
number = 48
# number of tickets per page:
number_of_tickets_per_page = 16
# number of columns:
columns = 2
# offset between right and left ticket, offset between upper and lower ticket
x_offset = 90.89
y_offset = 33.5975
# paragraph style for textframe with the ticket number:
style = "ticket-number"
# masterpage containing the layout of the ticket:
masterpage = "ticket-layout"

##################################
# beginning of Script:

# Get informations about text frame:
x,y = scribus.getPosition()
width, height = scribus.getSize()
counter = int(scribus.getText())
number_of_digits = len(scribus.getText())

# set miscellaneous variables...
number_per_column = number_of_tickets_per_page / columns
x_new = x
y_new = y + y_offset
counter_page = 0
counter_column = 1

# write numbers into dokument
while counter != number:
  while counter_page < number_of_tickets_per_page:
    while counter_column < number_per_column:
      counter = counter + 1
      counter_column = counter_column + 1
      frame = scribus.createText(x_new, y_new, width, height)
      scribus.setText(str(counter).zfill(number_of_digits), frame)
      scribus.setStyle(style, frame)
      y_new = y_new + y_offset
      if counter == number:
        break
    if counter == number:
      break
    x_new = x_new + x_offset
    y_new = y
    counter_page = counter_page + counter_column
    counter_column = 0
  if counter < number:
    counter_page = 0
    counter_column = 0
    scribus.newPage(-1, masterpage)
    scribus.gotoPage(scribus.pageCount())
    y_new = y
    x_new = x
